;**************************************;
;       Program      GrigSig                                      
;--------------------------------------;
;       Written   by J.Grigalashvili                               
;                july   2004                                               
;**************************************;

;-------------Registers----------------;

BN_VECTOR_H: .EQU    %10
BN_VECTOR_L: .EQU    %11

DR_VECTOR_H: .EQU    %12
DR_VECTOR_L: .EQU    %13

BL_VECTOR_H: .EQU    %14
BL_VECTOR_L: .EQU    %15

T1_VECTOR_H: .EQU    %16
T1_VECTOR_L: .EQU    %17                                                               
                                     
             .ORG    %00
             .WORD   BTN     ;Knopka
             .WORD   DOOR  ; Dver     
             .WORD   BELL    ; Zvanok
             .WORD   %0C
             .WORD   %0C
             .WORD   TMR1    ;Taimer 
;-----------Main   Program------------;

             .ORG    %0C
             DI
Beg:         LD      P2M,  #0
             LD      P3M,  #1
             LD      P01M, #4
             LD      SPL,  #%40
             LD      IPR,  #%31
             LD      PRE1, #%CB
             LD      T1,   #200

;-------- Wait Exit Intialization-----;

W_Ex_In:     LD      R6,   #5;  13 Cekund
             CLR     R7
             LD      P0,   #0
             LD      P2,   #1
             LD      IRQ,  #0
             LD      IMR,  #%20
             LD      TMR,  #%0C
             LD      R4,   #>W_Ex
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<W_Ex
             LD      T1_VECTOR_L,   R4
             EI
loop:        NOP
             HALT
             JR      loop

;--------- Wait   Exit ---------------;

W_Ex:        DECW    RR6
             JR      NZ,   W_Ex_End

;-------Close Intialization-----------;

Cl_In:       LD      P0,   #1
             CLR     P2
             LD      R5,   #18     ; 0,18 cekund               
             LD      R4,   #>Cl_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Cl_t
             LD      T1_VECTOR_L,   R4          
W_Ex_End:            IRET
                          
;---------- Close --------------------;

Cl_t:        DJNZ    R5,  Cl_End   ; Zakrvanie
             CLR     P0
;------- Start  Intialization --------;

St_In:       DI
             LD      R5,   #25           ; Miganie                                                           
             LD      R4,   #>B_In_Int
             LD      BN_VECTOR_H,   R4
             LD      R4,   #<B_In_Int
             LD      BN_VECTOR_L,   R4
             LD      R4,   #>W_En_In
             LD      DR_VECTOR_H,   R4
             LD      R4,   #<W_En_In
             LD      DR_VECTOR_L,   R4
             ld      R4,   #>M_On_In
             LD      BL_VECTOR_H,   R4
             LD      R4,   #<M_On_In
             LD      BL_VECTOR_L,   R4
             LD      R4,   #>St_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<St_t
             LD      T1_VECTOR_L,   R4
             LD      %18,  #59   ; V kajdii 1 chac
             CLR     %19       
             LD      IMR,  #%27
             CLR     IRQ
             EI
Cl_End:      IRET

Beg1:        JR      Beg

;--------- Start ---------------------;

St_t:        DJNZ    R5,   St2_End
             XOR     P2,   #%01     ; Miganie
             LD      R5,   #25
             DECW    %18
             JR      NZ,   St2_End

;------- Start1 Intialization --------;

M_On_In:     LD      R4,   #>St1_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<St1_t
             LD      T1_VECTOR_L,   R4
             LD      %1A,  #5
             LD      %1B,  0

;------- Start1 ----------------------;

St1_t:       DECW    %1A     ;Pocle zvonka
             JR      NZ,   St2_End 
                                    ;13 cekund zaderjka

;--------- Start2 Intialization-------;

             XOR     P2,   #%08
             LD      R4,   #>St2_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<St2_t
             LD      T1_VECTOR_L,   R4
             LD      R6,   #%1                
             CLR     R7

;--------- Start2 --------------------;

St2_t:       DJNZ    R5,   St2_End
             XOR     P2,   #%01       ; Miganie
             LD      R5,   #25
             DECW    RR6                ;2,2minut
             JR      NZ,   St2_End ; Magnitofon
             XOR     P2,   #%08
             JR            St_In
St2_End:     IRET

Beg2:        JR      Beg1

St_In1:      JR      St_In

;----Interrupt Servise Routine --------;

BTN:         LD      R8,   #3
             CLR     R9
delay1:       DECW    RR8
             JR      NZ,   delay1
             AND     IRQ,  #%FE
             TM      P3,   #%04
             JR      Z,    JMPB
             IRET


DOOR:        LD      R8,   #3
             CLR     R9
delay2:      DECW    RR8
             JR      NZ,   delay2
             AND     IRQ,  #%FD
             TM      P3,   #%08
             JR      Z,    JMPD
             IRET


BELL:        LD      R8,   #3
             CLR     R9
delay3:       DECW    RR8
             JR      NZ,   delay3
             AND     IRQ,  #%FB
             TM      P3,   #%02
             JR      Z,    JMPBL
             IRET

Beg3:        JR      Beg2
St_In2:      JR      St_In1

JMPB:        JP      @BN_VECTOR_H
JMPD:        JP      @DR_VECTOR_H
JMPBL:       JP      @BL_VECTOR_H 
TMR1:        JP      @T1_VECTOR_H
                         
;---- Button Interval Intialization---;

B_In_Int:    LD      %20,  #150
             LD      %21,  #50
             LD      %22,  #0

;--- Button Interval 1 Intialization--;                       

B_In_Int1:   LD      R5,   T1
             OR      R5,   #%2F
             CLR     P0
             LD      R6,   #%7
             LD      R4,   #>St_In
             LD      BN_VECTOR_H,   R4
             LD      R4,   #<St_In
             LD      BN_VECTOR_L,   R4           
             LD      R4,   #>Int1_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Int1_t
             LD      T1_VECTOR_L,   R4            
       
;------- Button Interval 1 ------------;

Int1_t:      XOR     P2,   #%02   
             DJNZ    R6,   Int1_t1 
             CLR     P2          ;Svist
             LD      R4,   #>Int1_t1
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Int1_t1
             LD      T1_VECTOR_L,   R4           
Int1_t1      DJNZ    R5,   Int1_t_End
             LD      P2,   #%01
             ADD     %22,  %21
             CP      %22,  %20
             JR      Z,    O_In_Int

;-- Button Interval 2 Intialization --;

             LD      R5,   %22        
             LD      R4,   #>St_In
             LD      BN_VECTOR_H,   R4
             LD      R4,   #<St_In
             LD      BN_VECTOR_L,   R4
             LD      R4,   #>Int2_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Int2_t
             LD      T1_VECTOR_L,   R4           
Int1_t_End:  IRET

Beg4:        JR      Beg3

;--------- Button Interval 2 ---------;

Int2_t:      DJNZ    R5,  Int2_t_End

;-- Button Interval 3 Intialization --;

             LD      R5,   #50
             LD      R4,   #>B_In_Int1
             LD      BN_VECTOR_H,   R4
             LD      R4,   #<B_In_Int1
             LD      BN_VECTOR_L,   R4          
             LD      R4,   #>Int3_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Int3_t
             LD      T1_VECTOR_L,   R4          
Int2_t_End:  IRET

;------- Button Interval 3 -----------;

Int3_t:      DJNZ    R5,  Int3_t_End
St_In3:      JR      St_In2

;------- Open Intialization ----------;

O_In_Int:    DI
             LD      R5,   #18 ; 0,18sekund
             CLR     P2            ;Otkrivanie
             LD      P0,   #%02
             LD      IMR,  #%20
             LD      R4,   #>O_In_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<O_In_t
             LD      T1_VECTOR_L,   R4          
             EI
Int3_t_End   IRET

;--------- Open ----------------------;

O_In_t:      DJNZ    R5,   O_t_End
             CLR     P0
             DI
             LD      IMR,  #%26
             LD      R10,  #23       
             CLR     R11                 
             LD      R4,   #>W_En_In
             LD      DR_VECTOR_H,   R4
             LD      R4,   #<W_En_In
             LD      DR_VECTOR_L,   R4           
             LD      R4,   #>Two_Mi
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Two_Mi
             LD      T1_VECTOR_L,   R4           
             EI
O_t_End:     IRET

;------- Interval-Open ---------------;

Two_Mi:      DECW    RR10     ;1 minuta
             JR      NZ,   W_En_In_End
             JR      Beg4  ;Ojidanie
                                                                                                            
;----- Wait Entrance Intialization-----;

W_En_In:     DI
             CLR     P0
             LD      R12,  #3   ; Otkrivanie
             CLR     R13         ;8 Cekunda
             LD      IMR,  #%20
             LD      R4,   #>W_En_t
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<W_En_t
             LD      T1_VECTOR_L,   R4           
             EI
W_En_In_End: IRET

;------- Wait Entrance ---------------;

W_En_t:      DECW    RR12
             JR      NZ,  Al_In_End

;------- Alarm Intialization----------;

Al_En:       LD      R14,  #250   ; 2,5 minuta 
             LD      R15,  #50 
             LD      P0,   #%04 
             CLR     P2        
             LD      R4,   #>Al
             LD      T1_VECTOR_H,   R4
             LD      R4,   #<Al
             LD      T1_VECTOR_L,   R4
Al_In_End:   IRET

;-------- Alarm ----------------------;

Al:          XOR     P2,   #%04   ; Cirena
             DJNZ    R14,  Al_In_End
             XOR     P0,   #%04
             LD      R14,  #250
             DJNZ    R15,  Al_In_End
             CLR     P0
             CLR     P2
             JR             St_In3
            .End



